/* GCC */
#include <fstream>

using namespace std;

const char base = 10;
char num1[60], num2[60], sum[60][60], res[60];
size_t num1_beg(61), num1_last, num2_beg(61), num2_last, sum_beg[60], sum_last[60], res_beg(61), res_last, sum_cnt;

bool sum_check(void)
{
    char carry, tmp;
    for(size_t sum_i = 0; sum_i < sum_cnt; ++sum_i)
        for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
            if(sum[sum_i][i] == '*')
                return false;
    size_t i;
    for(i = sum_last[0]; ; --i)
    {
        tmp = 0, carry = 0;
        bool is = false;
        for(size_t sum_i = 0; sum_i < sum_cnt; ++sum_i)
            if(sum_last[sum_i] >= i && sum_beg[sum_i] <= i)
            {
                is = true;
                tmp += sum[sum_i][i]-'0';
            }
        carry = tmp/base;
        tmp -= carry*base;
        if(!is)
        {
            if(i < res_beg || (res[i] != '*' && res[i] != carry))
                return false;
            break;
        }
        if(i < res_beg || (res[i] != '*' && res[i] != tmp+'0'))
            return false;
    }
    //if(i != res_beg)
        //return false;
    return true;
}

bool solve2(size_t n2_last)
{
    if(n2_last == num2_beg - 1)
        return sum_check();
    size_t sum_i = sum_cnt-1-(n2_last-num2_beg);
    char tmp[60], carry(0), tmpres;
    for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
        tmp[i] = sum[sum_i][i];
    if(num2[n2_last] == '*')
        for(size_t j = 1; j < 10; ++j)
        {
            num2[n2_last] = '0'+j;
            size_t sum_ii = sum_last[sum_i];
            bool br = false;
            for(size_t n1_i = num1_last; n1_i != num1_beg-1; --n1_i, --sum_ii)
            {
                tmpres = (num2[n2_last]-'0')*(num1[n1_i]-'0')+carry;
                carry = tmpres/base;
                tmpres -= carry*base;
                if(sum[sum_i][sum_ii] != '*' && sum[sum_i][sum_ii] != tmpres+'0')
                {
                    for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
                        sum[sum_i][i] = tmp[i];
                    num2[n2_last] = '*';
                    br = true;
                    break;
                }
                else
                    sum[sum_i][sum_ii] = tmpres+'0';
            }
            if(br)
                continue;
            if(carry)
            {
                if(sum_ii != sum_beg[sum_i] || (sum[sum_i][sum_ii] != '*' && sum[sum_i][sum_ii] != carry+'0'))
                {
                    for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
                        sum[sum_i][i] = tmp[i];
                    num2[n2_last] = '*';
                    continue;
                }
                else
                    sum[sum_i][sum_ii] = carry+'0';
            }
            if(solve2(n2_last-1))
                return true;
            for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
                sum[sum_i][i] = tmp[i];
            num2[n2_last] = '*';
        }
    else
    {
        size_t sum_ii = sum_last[sum_i];
        for(size_t n1_i = num1_last; n1_i != num1_beg-1; --n1_i, --sum_ii)
        {
            tmpres = (num2[n2_last]-'0')*(num1[n1_i]-'0')+carry;
            carry = tmpres/base;
            tmpres -= carry*base;
            if(sum[sum_i][sum_ii] != '*' && sum[sum_i][sum_ii] != tmpres+'0')
            {
                for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
                    sum[sum_i][i] = tmp[i];
                return false;
            }
            else
                sum[sum_i][sum_ii] = tmpres+'0';
        }
        if(carry)
        {
            if(sum_ii != sum_beg[sum_i] || (sum[sum_i][sum_ii] != '*' && sum[sum_i][sum_ii] != carry+'0'))
            {
                for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
                    sum[sum_i][i] = tmp[i];
                return false;
            }
            else
                sum[sum_i][sum_ii] = carry+'0';
        }
        if(solve2(n2_last-1))
            return true;
        for(size_t i = sum_beg[sum_i]; i != sum_last[sum_i]+1; ++i)
            sum[sum_i][i] = tmp[i];
    }
    return false;
}

bool solve(size_t n1_last)
{
    for(size_t i = n1_last; i != num1_beg-1; --i)
        if(num1[i] == '*')
        {
            for(size_t j = 1; j < 10; ++j)
            {
                num1[i] = '0'+j;
                if(solve(i-1))
                    return true;
                num1[i] = '*';
            }
        }
    if(solve2(num2_last))
    {
        solve2(num2_last);
        return true;
    }
    return false;
}

int main(void)
{
    char ch;
    for(size_t i = 0; i < 60; ++i)
        sum_beg[i] = 61;
    ifstream in("cripto.in");
    for(size_t i = 0; ; ++i)
    {
        ch = in.get();
        if(ch == '\n')
            break;
        num1[i] = ch;
        if(ch != ' ')
        {
            num1_last = i;
            if(num1_beg == 61)
                num1_beg = i;
        }
    }
    for(size_t i = 0; ; ++i)
    {
        ch = in.get();
        if(ch == '\n')
            break;
        num2[i] = ch;
        if(ch != ' ')
        {
            num2_last = i;
            if(num2_beg == 61)
                num2_beg = i;
        }
    }
    while((ch = in.get()) != '\n');
    for(size_t i = 0; ; ++i)
    {
        for(size_t j = 0; ; ++j)
        {
            ch = in.get();
            if(ch == '\n' || ch == '-')
                break;
            sum[i][j] = ch;
            if(ch != ' ')
            {
                sum_last[i] = j;
                if(sum_beg[i] == 61)
                    sum_beg[i] = j;
            }
        }
        if(ch == '-')
        {
            while((ch = in.get()) != '\n');
            sum_cnt = i;
            break;
        }
    }
    for(size_t i = 0; ; ++i)
    {
        ch = in.get();
        if(ch == '\n')
            break;
        res[i] = ch;
        if(ch != ' ')
        {
            res_last = i;
            if(res_beg == 61)
                res_beg = i;
        }
    }
    in.close();
    ofstream out("cripto.out");
    if(!solve(num1_last))
    {
        out << "No solution!\n";
        return 0;
    }
    for(size_t i = num1_beg; i != num1_last+1; ++i)
        out << num1[i];
    out << ' ';
    for(size_t i = num2_beg; i != num2_last+1; ++i)
        out << num2[i];
    out << '\n';
    out.close();
    return 0;
}
