/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

unsigned int n, i, d, k, a[10], otv;
vector <unsigned int> v[10];

int proc(unsigned int k)
{
    if(i == n - 1)
        return a[i] % k;

    v[i].push_back(0);
    v[i].push_back(a[i] % k);
    d = (v[i][1] * v[i][1]) % k;
    while(d != v[i][1])
    {
        v[i].push_back(d);
        if(d == 0)
            break;
        d = (d * v[i][1]) % k;
    }
    v[i][0] = v[i].back();
    v[i].pop_back();

    if(i == 0 && v[0][0] == 0)
    {
        if(a[1] >= v[0].size())
            return 0;

        if(n > 2 && a[2] > 1 && (a[1] + 1) * (a[1] - 1) >= v[0].size())
            return 0;
    }

    i++;
    d = proc(v[i - 1].size());
    i--;

    return v[i][d];
}

int main()
{
    freopen("remain.in", "r", stdin);
    freopen("remain.out", "w", stdout);

    scanf("%d %d", &n, &k);
    for(i = 0; i < n; i++)
        scanf("%d", &a[i]);

    i = 0;
    otv = proc(k);

    printf("%d\n", otv);

    return 0;
}







