/* GCC */
#include<stdio.h>
#include<string.h>
#include<vector>
#include<algorithm>
using namespace std;
vector<int> long_summ(vector<int> bas, vector<int> add)
{
    vector<int> u;
    u.resize(max(bas.size(), add.size())+2);
    for (int i=0; i<u.size(); i++) u[i] = 0;

    for (int i = 0; i<bas.size(); i++)
    {
        u[i+1] = (u[i] + add[i] + bas[i]) / 10;
        u[i] = (u[i] + add[i] + bas[i]) % 10;
    }
    for (int i = bas.size(); i<add.size(); i++)
    {
        u[i+1] = (u[i] + add[i]) / 10;
        u[i] = (u[i] + add[i]) % 10;
    }
    while (u[u.size()-1] == 0 && u.size() > 1) u.pop_back();
    return u;
}
main()
{
    /*
              .
            . .
             .
              
            
             ,
             .
              .
               ,
               ,
                ,
            ,
               .
               ,
              ,
              ,  ,
               , , 
                 ,
                 
               
                -  
            
               ,   .
                -
                .
                
            , ,    .
            ,  ,    
              ,    ,
             ,     
                 
               .
             .
            ,  ,
                .
              , .

              . .

                , 11- 18.02.2016


    */
    FILE *fi = fopen("cripto.in", "r"), *fo = fopen("cripto.out", "w");
    char i1[100], i2[100], mn[100][100], res[200];
    int sz, fz = 0, c=0, mlt, w;
    fscanf(fi, "%s%s", i1, i2);
    w = strlen(i1);
    for (int i=0; i<w; i++) if (i1[i] == '*') fz = 1;
    sz = strlen(i2);
    for (int i=0; i<sz; i++)
    {
        if (i2[i] == '*') fz = 1;
    }
    if (fz) fprintf(fo, "No solution!\n"); else
    {
        fscanf(fi, "%*s");
        for (int i = 0; i<sz; i++) if (i2[i] != '0') fscanf(fi, "%s", mn[i]);
        fscanf(fi, "%s", res); if (res[0] != '-')
        {
            fprintf(fo, "No solution!\n");
            fclose(fi);
            fclose(fo);
            return 0;
        }
        fscanf(fi, "%s", res);
        vector<int> tmp, rbin;
        rbin.push_back(0);
        for (int i=0; i<sz; i++) if (i2[i] != '0')
        {
            mlt = i2[sz - i - 1]-48;
            tmp.clear();
            tmp.resize(w+1);
            for (int j=0; j<tmp.size(); j++) tmp[i] = 0;
            for (int j = 0; j<w; j++)
            {
                tmp[j+1] = (tmp[j] + (i1[sz - j-1 ]-48)*mlt ) / 10;
                tmp[j] = (tmp[j] + (i1[sz - j-1]-48)*mlt ) % 10 ;
            }
            if (tmp[tmp.size()-1] == 0) tmp.pop_back();
            reverse(tmp.begin(), tmp.end());

            if (tmp.size() != strlen(mn[i])) {
                fprintf(fo, "No solution!\n");
                fclose(fi);
                fclose(fo);
                return 0;
            }
            for (int j=0; j<tmp.size(); j++) if (mn[i][j] != '*')
                if (mn[i][j] - 48 != tmp[j]) {
                fprintf(fo, "No solution!\n");
                fclose(fi);
                fclose(fo);
                return 0;
            }
            for (int j = 0; j<i; j++) tmp.push_back(0);
            reverse(tmp.begin(), tmp.end());

            rbin = long_summ(rbin, tmp);

         }
        if (rbin.size() != strlen(res)) {
                fprintf(fo, "No solution!\n");
                fclose(fi);
                fclose(fo);
                return 0;
            }
        reverse(rbin.begin(), rbin.end());
        for (int j=0; j<rbin.size(); j++) if (res[j] != '*')
                if (res[j] - 48 != rbin[j]) {
                fprintf(fo, "No solution!\n");
                fclose(fi);
                fclose(fo);
                return 0;
            }
        fprintf(fo, "%s %s\n", i1, i2);
    }




    fclose(fi);
    fclose(fo);
    return 0;
}
