/* GCC */
#include <fstream>

using namespace std;

struct progression
{
    size_t first;
    size_t diff;
};

size_t powermod(size_t value, size_t p, size_t m)
{
    size_t res(1);
    for(value %= m; p; p >>= 1, (value *= value) %= m)
        if(p & 1)
            (res *= value) %= m;
    return res;
}

size_t n, hlp[1<<16] = {}, a[10], tmp;

int main(void)
{
    progression a_period[10];
    ifstream in("remain.in");
    in >> n >> a[0] >> a[1];
    tmp = a[1] % a[0];
    hlp[tmp] = 1;
    for(size_t j = 2; ; ++j)
    {
        (tmp *= a[1]) %= a[0];
        if(hlp[tmp] == 0)
            hlp[tmp] = j;
        else
        {
            a_period[1].first = hlp[tmp];
            a_period[1].diff = j-hlp[tmp];
            break;
        }
    }
    for(size_t i = 2; i < n; ++i)
    {
        in >> a[i];
        for(size_t j = 0; j < a_period[i-1].diff; ++j)
            hlp[j] = 0;
        tmp = a[i] % a_period[i-1].diff;
        hlp[tmp] = 1;
        for(size_t j = 2; ; ++j)
        {
            (tmp *= a[i]) %= a_period[i-1].diff;
            if(hlp[tmp] == 0)
                hlp[tmp] = j;
            else
            {
                a_period[i].first = hlp[tmp];
                a_period[i].diff = j-hlp[tmp];
                break;
            }
        }
    }
    in >> a[n];
    in.close();
    if(n == 1)
        a[1] %= a[0];
    else if(n == 2)
        a[1] = powermod(a[1], a[2], a[0]);
    else
    {
        a[n-1] = powermod(a[n-1], a[n], a_period[n-2].diff);
        for(size_t i = n-2; i > 1; --i)
            a[i] = powermod(a[i], (a[i+1] % a_period[i].diff) + (a_period[i].first/a_period[i].diff + 1)*a_period[i].diff, a_period[i-1].diff);
        a[1] = powermod(a[1], (a[2] % a_period[1].diff) + (a_period[1].first/a_period[1].diff + 1)*a_period[1].diff, a[0]);
    }
    ofstream out("remain.out");
    out << a[1] << '\n';
    out.close();
    return 0;
}
